com.smartgwt.client.widgets.drawing

## Class DrawSector

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawSector

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers

      public class DrawSector
      extends DrawItem

  DrawItem subclass to render Pie Slices.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawSector()`
    `DrawSector(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `Point` | `getArcMidpoint()` Calculates the coordinates of the midpoint of this DrawSector's circular arc.
    `static Point` | `getArcMidpoint(double centerX, double centerY, double startAngle, double endAngle, double radius)` Calculates the midpoint coordinates of the circular arc of the sector defined by the given centerPoint, startAngle, endAngle, and radius.
    `Point` | `getCenter()` Returns the sector's `centerPoint`.
    `Point` | `getCenterPoint()` Center point of the sector
    `float` | `getEndAngle()` Deprecated. `GwtFloatVsDouble`
    `double` | `getEndAngleAsDouble()` End angle of the sector in degrees.
    `KnobType[]` | `getKnobs()` DrawSector only supports the `KnobType.MOVE` knob type.
    `static DrawSector` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `int` | `getRadius()` Radius of the sector.
    `float` | `getRotation()` Deprecated. `GwtFloatVsDouble`
    `double` | `getRotationAsDouble()` Rotation in degrees about the `centerPoint` of the DrawSector.
    `boolean` | `getShowTitleLabelBackground()` If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?
    `float` | `getStartAngle()` Deprecated. `GwtFloatVsDouble`
    `double` | `getStartAngleAsDouble()` Start angle of the sector in degrees.
    `void` | `moveBy(int x, int y)` Move the DrawSector by the specified amounts.
    `void` | `setCenterPoint(Point centerPoint)` Center point of the sector If this method is called after the component has been drawn/initialized: Change the center point for this sector.
    `static void` | `setDefaultProperties(DrawSector drawSectorProperties)` Class level method to set the default properties of this class.
    `void` | `setEndAngle(double endAngle)` End angle of the sector in degrees.
    `void` | `setEndAngle(float endAngle)` Deprecated. `GwtFloatVsDouble`
    `void` | `setKnobs(KnobType... knobs)` DrawSector only supports the `KnobType.MOVE` knob type.
    `void` | `setRadius(int radius)` Radius of the sector.
    `void` | `setRotation(double rotation)` Rotation in degrees about the `centerPoint` of the DrawSector.
    `void` | `setRotation(float rotation)` Deprecated. `GwtFloatVsDouble`
    `void` | `setShowTitleLabelBackground(boolean showTitleLabelBackground)` If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?
    `void` | `setStartAngle(double startAngle)` Start angle of the sector in degrees.
    `void` | `setStartAngle(float startAngle)` Deprecated. `GwtFloatVsDouble`

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, changeAutoChildDefaults, changeAutoChildDefaults, changeAutoChildDefaults, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getBoundingBoxAsDouble, getCanDrag, getCanHover, getCanvasAutoChild, getContextMenu, getCornerResizeKnob, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawItemAutoChild, getDrawPane, getEditProxyConstructor, getEndArrow, getEndKnob, getEventOpaque, getFillColor, getFillGradient, getFillGradientAsString, getFillOpacity, getFormItemAutoChild, getHoverDelay, getHoverHTML, getKeepInParentRect, getLineCap, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnob, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRef, getResizeBoundingBox, getResizeBoundingBoxAsDouble, getResizeKnobPoints, getResizeOutline, getResizeViaLocalTransformOnly, getScale, getShadow, getShowHover, getShowResizeOutline, getSideResizeKnob, getStartArrow, getStartKnob, getSvgString, getTitle, getTitleLabel, getTitleLabelBackground, getTitleLabelPadding, getTitleRotationMode, getTranslate, getXShearFactor, getYShearFactor, hide, hideAllKnobs, hideKnobs, hideKnobs, hover, isInBounds, isPointInPath, moveTo, resizeBy, resizeTo, rotateBy, rotateTo, scaleBy, scaleTo, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setCanDrag, setCanHover, setCenterPoint, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEditProxyConstructor, setEndArrow, setEventOpaque, setFillColor, setFillGradient, setFillGradient, setFillOpacity, setHoverDelay, setKeepInParentRect, setKeepInParentRect, setLineCap, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setPropertyValue, setProportionalResizeModifiers, setProportionalResizing, setResizeKnobPoints, setResizeViaLocalTransformOnly, setScale, setShadow, setShapeData, setShowHover, setShowResizeOutline, setStartArrow, setTitle, setTitleLabelPadding, setTitleRotationMode, setTranslate, setXShearFactor, setYShearFactor, show, showAllKnobs, showKnobs, showKnobs, supportsEndArrow, supportsStartArrow`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `applyFactoryProperties, asSGWTComponent, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, getTestInstance, hasAutoAssignedID, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setID, setJavaScriptObject, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawSector

          public DrawSector()

    - #### DrawSector

          public DrawSector(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawSector getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setCenterPoint

          public void setCenterPoint(Point centerPoint)

      Center point of the sector
      If this method is called after the component has been drawn/initialized: Change the center point for this sector.
      Parameters:
        `centerPoint` - X coordinate of the center point (in the global coordinate system).. Default value is [0,0]

    - #### getCenterPoint

          public Point getCenterPoint()

      Center point of the sector
      Returns:
        Point

    - #### setEndAngle

          public void setEndAngle(float endAngle)
                           throws java.lang.IllegalStateException

      Deprecated. `GwtFloatVsDouble`
      End angle of the sector in degrees.
      Parameters:
        `endAngle` - Default value is 20.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getEndAngle

          public float getEndAngle()

      Deprecated. `GwtFloatVsDouble`
      End angle of the sector in degrees.
      Returns:
        float

    - #### setEndAngle

          public void setEndAngle(double endAngle)
                           throws java.lang.IllegalStateException

      End angle of the sector in degrees.
      Parameters:
        `endAngle` - Default value is 20.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getEndAngleAsDouble

          public double getEndAngleAsDouble()

      End angle of the sector in degrees.
      Returns:
        double

    - #### setKnobs

          public void setKnobs(KnobType... knobs)
                        throws java.lang.IllegalStateException

      DrawSector only supports the `KnobType.MOVE` knob type.
      Overrides:
        `setKnobs` in class `DrawItem`
      Parameters:
        `knobs` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created
      See Also:
        `DrawItem.setKnobs(com.smartgwt.client.types.KnobType...)`

    - #### getKnobs

          public KnobType[] getKnobs()

      DrawSector only supports the `KnobType.MOVE` knob type.
      Overrides:
        `getKnobs` in class `DrawItem`
      Returns:
        KnobType...
      See Also:
        `DrawItem.getKnobs()`

    - #### setRadius

          public void setRadius(int radius)
                         throws java.lang.IllegalStateException

      Radius of the sector.
      Parameters:
        `radius` - Default value is 100
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getRadius

          public int getRadius()

      Radius of the sector.
      Returns:
        int

    - #### setRotation

          public void setRotation(float rotation)
                           throws java.lang.IllegalStateException

      Deprecated. `GwtFloatVsDouble`
      Rotation in degrees about the `centerPoint` of the DrawSector. The positive direction is clockwise.
      Overrides:
        `setRotation` in class `DrawItem`
      Parameters:
        `rotation` - Default value is 0.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getRotation

          public float getRotation()

      Deprecated. `GwtFloatVsDouble`
      Rotation in degrees about the `centerPoint` of the DrawSector. The positive direction is clockwise.
      Overrides:
        `getRotation` in class `DrawItem`
      Returns:
        float

    - #### setRotation

          public void setRotation(double rotation)
                           throws java.lang.IllegalStateException

      Rotation in degrees about the `centerPoint` of the DrawSector. The positive direction is clockwise.
      Overrides:
        `setRotation` in class `DrawItem`
      Parameters:
        `rotation` - Default value is 0.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getRotationAsDouble

          public double getRotationAsDouble()

      Rotation in degrees about the `centerPoint` of the DrawSector. The positive direction is clockwise.
      Overrides:
        `getRotationAsDouble` in class `DrawItem`
      Returns:
        double

    - #### setShowTitleLabelBackground

          public void setShowTitleLabelBackground(boolean showTitleLabelBackground)
                                           throws java.lang.IllegalStateException

      If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?

      This defaults to true for `DrawSector`s and shapes that are not commonly filled (e.g. `DrawLine`s).

      Note : This is an advanced setting

      Overrides:
        `setShowTitleLabelBackground` in class `DrawItem`
      Parameters:
        `showTitleLabelBackground` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getShowTitleLabelBackground

          public boolean getShowTitleLabelBackground()

      If the `titleLabel` is showing, should the `titleLabelBackground` be created and placed behind the `titleLabel`?

      This defaults to true for `DrawSector`s and shapes that are not commonly filled (e.g. `DrawLine`s).

      Overrides:
        `getShowTitleLabelBackground` in class `DrawItem`
      Returns:
        boolean

    - #### setStartAngle

          public void setStartAngle(float startAngle)
                             throws java.lang.IllegalStateException

      Deprecated. `GwtFloatVsDouble`
      Start angle of the sector in degrees. Default of 0.0 will create a sector that starts with a line from the `centerPoint` and extends to the right for the indicated `radius`, then sweeps clockwise toward the `endAngle`.
      Parameters:
        `startAngle` - Default value is 0.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getStartAngle

          public float getStartAngle()

      Deprecated. `GwtFloatVsDouble`
      Start angle of the sector in degrees. Default of 0.0 will create a sector that starts with a line from the `centerPoint` and extends to the right for the indicated `radius`, then sweeps clockwise toward the `endAngle`.
      Returns:
        float

    - #### setStartAngle

          public void setStartAngle(double startAngle)
                             throws java.lang.IllegalStateException

      Start angle of the sector in degrees. Default of 0.0 will create a sector that starts with a line from the `centerPoint` and extends to the right for the indicated `radius`, then sweeps clockwise toward the `endAngle`.
      Parameters:
        `startAngle` - Default value is 0.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getStartAngleAsDouble

          public double getStartAngleAsDouble()

      Start angle of the sector in degrees. Default of 0.0 will create a sector that starts with a line from the `centerPoint` and extends to the right for the indicated `radius`, then sweeps clockwise toward the `endAngle`.
      Returns:
        double

    - #### getArcMidpoint

          public Point getArcMidpoint()

      Calculates the coordinates of the midpoint of this DrawSector's circular arc. The formula for this point is:

      >     var averageAngle = (startAngle + endAngle) / 2; // in degrees
      >      [centerX + radius * cosdeg(averageAngle), centerY + radius * sindeg(averageAngle)]

      Returns:
        the coordinates of the midpoint of the arc.

    - #### getCenter

          public Point getCenter()

      Returns the sector's `centerPoint`.
      Overrides:
        `getCenter` in class `DrawItem`
      Returns:
        the current centerPoint

    - #### moveBy

          public void moveBy(int x,
                             int y)

      Move the DrawSector by the specified amounts.
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `x` - number of pixels to move by horizontally
        `y` - number of pixels to move by vertically

    - #### getArcMidpoint

          public static Point getArcMidpoint(double centerX,
                                             double centerY,
                                             double startAngle,
                                             double endAngle,
                                             double radius)

      Calculates the midpoint coordinates of the circular arc of the sector defined by the given centerPoint, startAngle, endAngle, and radius. The formula for this point is:

      >     var averageAngle = (startAngle + endAngle) / 2; // in degrees
      >      [centerX + radius * cosdeg(averageAngle), centerY + radius * sindeg(averageAngle)]

      Parameters:
        `centerX` - X coordinate of the center point of the sector.
        `centerY` - Y coordinate of the center point of the sector.
        `startAngle` - start angle of the sector in degrees.
        `endAngle` - end angle of the sector in degrees.
        `radius` - radius of the sector.
      Returns:
        the coordinates of the midpoint of the arc.

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawSector drawSectorProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `drawSectorProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`